
import UIKit
import CoreImage
import ImageIO

class HipsterizeViewController: UIViewController {
  @IBOutlet weak var imageView: UIImageView!

  var image: UIImage?

  override func viewDidLoad() {
    super.viewDidLoad()
  }

  @IBAction func selectPhotoTapped(sender: AnyObject) {
    let picker = UIImagePickerController()
    picker.delegate = self
    presentViewController(picker, animated: true, completion: nil)
  }

  override func didReceiveMemoryWarning() {
    super.didReceiveMemoryWarning()
    // Dispose of any resources that can be recreated.
  }

  func startEditingImage() {
    if let image = image {
      imageView.image = image
      autoHipsterizeCurrentImage()
    }
  }

  func autoHipsterizeCurrentImage() {
    if let image = self.image {
      let hipsterize = Hipsterize(image: image)
      imageView.image = hipsterize.processedImage()
    }
  }

}

extension HipsterizeViewController: UIImagePickerControllerDelegate, UINavigationControllerDelegate {
  func imagePickerController(picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [NSObject : AnyObject]) {
    self.image = info[UIImagePickerControllerOriginalImage] as? UIImage
    startEditingImage()
    dismissViewControllerAnimated(true, completion: nil)
  }

  func imagePickerControllerDidCancel(picker: UIImagePickerController) {
    dismissViewControllerAnimated(true, completion: nil)
  }
}
